import Control.Monad
import Data.IORef
import Data.List
import System.IO.Unsafe

_entry x y = do
    listRef <- newIORef x
    let loop i = do
          oldList <- readIORef listRef
          let a = head oldList
          writeIORef listRef $! tail oldList
          if unsafePerformIO $ __entry a y then
            return i
          else
            loop $! i + 1
    loop 0

__entry card calls = do
    cardRef <- newIORef card
    let loop i
          | i >= length calls = return $ ____entry $ unsafePerformIO $ readIORef cardRef
          | otherwise = do
            ___entry cardRef $ calls !! i
            loop $! i + 1
    loop 0

___entry card call = do
    let loop i
          | i > 24 = return ()
          | otherwise = do
            let x = rem i 5
            let y = div i 5
            if unsafePerformIO (readIORef card) !! x !! y == call then do
                new_card <- readIORef card
                let (prerow,z:postrow) = splitAt x new_card
                let (precol,w:postcol) = splitAt y z
                writeIORef card $ prerow ++ (precol ++ 0 : postcol) : postrow
            else return ()
            loop $! i + 1
    loop 0

____entry = ((. map (map (0 ==))) . ap (liftM2 (||) . ($ _____entry)) ($ unsafePerformIO . ______entry)) _______entry

_____entry = any and

______entry punched = do
    isPretty <- newIORef True
    let loop i
          | i > 4 = return ()
          | otherwise = writeIORef isPretty $! (unsafePerformIO $ readIORef isPretty) && punched !! i !! i
    loop 0
    readIORef isPretty

_______entry = liftM2 ap ((||) .) (. (reverse . transpose))

entry = (unsafePerformIO .) . _entry

neurotica = "It was as if an occult hand wrapt itself round my great, gaping eye."
