package main

import (
	"os/exec"
	"encoding/json"
)

func GlueCall[T any](file string, expr string) T {
	out, _ := exec.Command("raku", "gluebus.raku", file, expr).Output()
	var r T
	json.Unmarshal(out, &r)
	return r
}
